unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, RGraphics;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonSaveBitmap: TButton;
    ButtonLoadBitmap: TButton;
    ButtonClose: TButton;
    Edit1: TEdit;
    Image1: TImage;
    ListBox1: TListBox;
    Panel1: TPanel;
    procedure ButtonSaveBitmapClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Read_BM_Info;
    procedure BMStream_to_Image;
    procedure ButtonLoadBitmapClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

  private
    { private declarations }
    Bitmap : TBitmap;
    FileName : String;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin

  FileName:='ball_01.bmp';

  Edit1.Text:=FileName;
  Bitmap:=TBitmap.Create;

  ButtonLoadBitmapClick(Sender);

end;





procedure TForm1.Read_BM_Info;
var
  line : String;
  FillBytes : LongWord;
begin
  ListBox1.Clear;

  line:='BITMAPFILEHEADER';
  ListBox1.Items.Add(line);
  line:='================';
  ListBox1.Items.Add(line);
  line:='bfType = '+IntToHex(Bitmap.BITMAPFILEHEADER.bfType,4);
  ListBox1.Items.Add(line);
  line:='bfSize = '+IntToStr(Bitmap.BITMAPFILEHEADER.bfSize);
  ListBox1.Items.Add(line);
  line:='bfReserved = '+IntToStr(Bitmap.BITMAPFILEHEADER.bfReserved);
  ListBox1.Items.Add(line);
  line:='bfOffBits = '+IntToStr(Bitmap.BITMAPFILEHEADER.bfOffBits);
  ListBox1.Items.Add(line);

  ListBox1.Items.Add(' ');

  line:='BITMAPINFOHEADER';
  ListBox1.Items.Add(line);
  line:='================';
  ListBox1.Items.Add(line);
  line:='biSize = '+IntToStr(Bitmap.BITMAPINFOHEADER.biSize);
  ListBox1.Items.Add(line);
  line:='biWidth = '+IntToStr(Bitmap.BITMAPINFOHEADER.biWidth);
  ListBox1.Items.Add(line);
  line:='biHeight = '+IntToStr(Bitmap.BITMAPINFOHEADER.biHeight);
  ListBox1.Items.Add(line);
  line:='biPlanes = '+IntToStr(Bitmap.BITMAPINFOHEADER.biPlanes);
  ListBox1.Items.Add(line);
  line:='biBitCount = '+IntToStr(Bitmap.BITMAPINFOHEADER.biBitCount);
  ListBox1.Items.Add(line);
  line:='biCompression = '+IntToStr(Bitmap.BITMAPINFOHEADER.biCompression);
  ListBox1.Items.Add(line);
  line:='biSizeImage = '+IntToStr(Bitmap.BITMAPINFOHEADER.biSizeImage);
  ListBox1.Items.Add(line);
  line:='biXPelsPerMeter = '+IntToStr(Bitmap.BITMAPINFOHEADER.biXPelsPerMeter);
  ListBox1.Items.Add(line);
  line:='biYPelsPerMeter = '+IntToStr(Bitmap.BITMAPINFOHEADER.biYPelsPerMeter);
  ListBox1.Items.Add(line);
  line:='biClrUsed = '+IntToStr(Bitmap.BITMAPINFOHEADER.biClrUsed);
  ListBox1.Items.Add(line);
  line:='biClrImportant = '+IntToStr(Bitmap.BITMAPINFOHEADER.biClrImportant);
  ListBox1.Items.Add(line);

  ListBox1.Items.Add(' ');
  line:='FileSize (Raw) = '+IntToStr(Bitmap.BM_FileSize);
  ListBox1.Items.Add(line);

  line:='FileSize (Raw without Header) = '+IntToStr(Bitmap.BM_FileSize-14-
                                 Bitmap.BITMAPINFOHEADER.biSize);
  ListBox1.Items.Add(line);

  FillBytes:=0;

  if (Bitmap.Width mod 4)>0 then
    FillBytes:=(((Bitmap.Width div 4)+1)*4)-Bitmap.Width;

  line:='DataSize ((W+F)*H*3) = '+IntToStr((Bitmap.Width+FillBytes)*Bitmap.Height*3);
  ListBox1.Items.Add(line);


end; { procedure TForm1.Read_BM_Info }








procedure TForm1.BMStream_to_Image;
var
  x_pix, y_pix,
  x1, y1, x2, y2,
  px, py : Integer;
  BM_Color : TColor;
  SB_Pixel_32ABGR : LongWord;
  SB_Pixel_24RGB : TPixel_24RGB;


    function Color_32ABGR_to_Color24RGB(Pixel_Color : LongWord) : TPixel_24RGB;
    var
      fa : LongWord;
      Pixel_BMP : TPixel_24RGB;
      Pixel_Byte : Byte;
    begin

      fa:=Pixel_Color and $000000FF;
      Pixel_Byte:=fa;
      Pixel_BMP.Red:=Pixel_Byte;

      fa:=Pixel_Color shr 8;
      fa:=fa and $000000FF;
      Pixel_Byte:=fa;
      Pixel_BMP.Green:=Pixel_Byte;

      fa:=Pixel_Color shr 16;
      fa:=fa and $000000FF;
      Pixel_Byte:=fa;
      Pixel_BMP.Blue:=Pixel_Byte;

      Result:=Pixel_BMP;

    end; { function Color_32ABGR_to_Color24RGB }




    function Color24RGB_to_TColor(Pixel_Color : TPixel_24RGB) : TColor;
    var
      fa, fb : TColor;
      Pixel_Byte : Byte;
    begin

      Pixel_Byte:=Pixel_Color.Red;
      fb:=Pixel_Byte shl 16;
      fa:=fb;

      Pixel_Byte:=Pixel_Color.Green;
      fb:=Pixel_Byte shl 8;
      fa:=fa or fb;

      Pixel_Byte:=Pixel_Color.Blue;
      fb:=Pixel_Byte;
      fa:=fa or fb;

      Result:=fa;

    end; { function Color24RGB_to_TColor }



begin
  x_pix:=Panel1.ClientWidth;
  x_pix:=x_pix div Bitmap.Width;
  y_pix:=Panel1.ClientHeight;
  y_pix:=y_pix div Bitmap.Height;
  Image1.Picture.Bitmap.Width:=x_pix*Bitmap.Width;
  Image1.Picture.Bitmap.Height:=y_pix*Bitmap.Height;

  Bitmap.BM_RAW_Memory.Position:=0;

  for y1:=0 to Bitmap.Height-1 do begin

    for x1:=0 to Bitmap.Width-1 do begin

      Bitmap.BM_RAW_Memory.Read(SB_Pixel_32ABGR,4);
      SB_Pixel_24RGB:=Color_32ABGR_to_Color24RGB(SB_Pixel_32ABGR);

      for y2:=0 to y_pix-1 do begin

        for x2:=0 to x_pix-1 do begin
            px:=(x1*x_pix)+x2;
            py:=(y1*y_pix)+y2;
            BM_Color:=Color24RGB_to_TColor(SB_Pixel_24RGB);
            Image1.Picture.Bitmap.Canvas.Pixels[px,py]:=BM_Color;

        end;

      end;

    end;

  end;


end; { procedure TForm1.Read_BM_Info }







procedure TForm1.ButtonLoadBitmapClick(Sender: TObject);
begin

  FileName:=Edit1.Text;

  if fileexists(FileName) then begin
    Bitmap.LoadFromFile(FileName);
    Read_BM_Info;
    BMStream_to_Image;
  end
  else begin
    ListBox1.Clear;
    ListBox1.Items.Add('*** File:'+FileName+' not found ...');
  end;


end; { procedure TForm1.ButtonLoadClick }






procedure TForm1.ButtonSaveBitmapClick(Sender: TObject);
var
  SaveName : String;
begin

   SaveName:=Edit1.Text+'_new';

   if FileExists(SaveName) then
     DeleteFile(SaveName);

   Bitmap.SaveToFile(SaveName);

end; { procedure TForm1.ButtonSaveBitmapClick }







procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
  Close;
end; { procedure TForm1.ButtonCloseClick }




procedure TForm1.FormDestroy(Sender: TObject);
begin
  ListBox1.Items.SaveToFile('ListBox1.txt');
  Bitmap.Free;
end;




end.

